/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.fel.pjv.cars.data;

/**
 *
 * @author martin
 */
public class TimeSpan {
    private int hour;
    private int minute;
    private int second;

    public TimeSpan() {
        this.hour=0;
        this.minute=0;
        this.second=0;
    }

    public void setTime(int hour, int minute, int second){
    if (second >= 60 || second < 0) {
            this.second = 0;
        } else {
            this.second = second;
        }
        if (minute >= 60 || minute < 0) {
            this.minute = 0;
        } else {
            this.minute = minute;
        }

        if (hour < 0) {
            this.hour = 0;
        } else {
            this.hour = hour;
        }
    }
    
    public TimeSpan(int hour, int minute, int second) {        
       setTime(hour,minute,second);
    }

    public TimeSpan(int second) {
         this(second/60,second%60);     
    }

    public TimeSpan(int minute, int second) {
        this(minute/60, minute%60, second);
    }
    
    public TimeSpan(TimeSpan ts){
     this.second=ts.second;
     this.minute=ts.minute;
     this.hour=ts.hour;
    }
    
    public TimeSpan add(int second){
        int addMinute=0;
        int addHour=0;
        addMinute=(this.second+second)/60;
        addHour=addMinute/60;
        addMinute=addMinute%60;
        this.second=(this.second+second)%60;
        this.minute+=addMinute;
        this.hour+=addHour;
        return this;
    }
    
    
    public int getTotalSeconds(){
        return hour*3600+minute*60+second;
    }

    @Override
    public int hashCode() {
        return getTotalSeconds();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final TimeSpan other = (TimeSpan) obj;
        return this.getTotalSeconds()==other.getTotalSeconds();
    }

    @Override
    public String toString() {
        return hour + " h " + minute + " m " + second + " s";
    }
    
    
    
    
    
}
